/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.php4.lexer;

import java.io.*;
import java.util.*;
import org.sablecc.php4.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.HTML;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);
                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 0: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 0: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.HTML; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.HEREDOC; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 87:
                        {
                            Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 88:
                        {
                            Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 89:
                        {
                            Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 90:
                        {
                            Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 91:
                        {
                            Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 92:
                        {
                            Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 93:
                        {
                            Token token = new93(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 94:
                        {
                            Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 95:
                        {
                            Token token = new95(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 96:
                        {
                            Token token = new96(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 97:
                        {
                            Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 98:
                        {
                            Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 99:
                        {
                            Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 100:
                        {
                            Token token = new100(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 101:
                        {
                            Token token = new101(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 102:
                        {
                            Token token = new102(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 103:
                        {
                            Token token = new103(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 104:
                        {
                            Token token = new104(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 105:
                        {
                            Token token = new105(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 106:
                        {
                            Token token = new106(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 107:
                        {
                            Token token = new107(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 108:
                        {
                            Token token = new108(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 109:
                        {
                            Token token = new109(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 110:
                        {
                            Token token = new110(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 111:
                        {
                            Token token = new111(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 112:
                        {
                            Token token = new112(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 113:
                        {
                            Token token = new113(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 114:
                        {
                            Token token = new114(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 115:
                        {
                            Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.STRING; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                            Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 2: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                            Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.BACKTICK; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                            Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 4: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                            Token token = new119(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 2: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                            Token token = new120(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 3: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                            Token token = new121(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 4: state = State.CODE; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                            Token token = new122(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 123:
                        {
                            Token token = new123(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 124:
                        {
                            Token token = new124(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 125:
                        {
                            Token token = new125(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 126:
                        {
                            Token token = new126(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 127:
                        {
                            Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 128:
                        {
                            Token token = new128(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 129:
                        {
                            Token token = new129(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 130:
                        {
                            Token token = new130(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 131:
                        {
                            Token token = new131(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 132:
                        {
                            Token token = new132(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 133:
                        {
                            Token token = new133(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.STRING; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                            Token token = new134(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.STRING; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                            Token token = new135(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.HEREDOC; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                            Token token = new136(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch (state.id())
                            {
                              case 1: state = State.BACKTICK; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                            Token token = new137(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TCodePrint(line, pos); }
    Token new1(String text, int line, int pos) { return new TCodeStart(text, line, pos); }
    Token new2(String text, int line, int pos) { return new THtmldata(text, line, pos); }
    Token new3(int line, int pos) { return new TCodeEnd(line, pos); }
    Token new4(String text, int line, int pos) { return new TIf(text, line, pos); }
    Token new5(String text, int line, int pos) { return new TElseif(text, line, pos); }
    Token new6(String text, int line, int pos) { return new TIfColon(text, line, pos); }
    Token new7(String text, int line, int pos) { return new TElseifColon(text, line, pos); }
    Token new8(String text, int line, int pos) { return new TEndif(text, line, pos); }
    Token new9(String text, int line, int pos) { return new TElse(text, line, pos); }
    Token new10(String text, int line, int pos) { return new TElseColon(text, line, pos); }
    Token new11(String text, int line, int pos) { return new TContinue(text, line, pos); }
    Token new12(String text, int line, int pos) { return new TForeach(text, line, pos); }
    Token new13(String text, int line, int pos) { return new TEndforeach(text, line, pos); }
    Token new14(String text, int line, int pos) { return new TFor(text, line, pos); }
    Token new15(String text, int line, int pos) { return new TAs(text, line, pos); }
    Token new16(String text, int line, int pos) { return new TEndfor(text, line, pos); }
    Token new17(String text, int line, int pos) { return new TWhile(text, line, pos); }
    Token new18(String text, int line, int pos) { return new TEndwhile(text, line, pos); }
    Token new19(String text, int line, int pos) { return new TDo(text, line, pos); }
    Token new20(String text, int line, int pos) { return new TSwitch(text, line, pos); }
    Token new21(String text, int line, int pos) { return new TCase(text, line, pos); }
    Token new22(String text, int line, int pos) { return new TDefault(text, line, pos); }
    Token new23(String text, int line, int pos) { return new TEndswitch(text, line, pos); }
    Token new24(String text, int line, int pos) { return new TBreak(text, line, pos); }
    Token new25(String text, int line, int pos) { return new TFunction(text, line, pos); }
    Token new26(String text, int line, int pos) { return new TReturn(text, line, pos); }
    Token new27(String text, int line, int pos) { return new TExit(text, line, pos); }
    Token new28(String text, int line, int pos) { return new TVar(text, line, pos); }
    Token new29(String text, int line, int pos) { return new TGlobal(text, line, pos); }
    Token new30(String text, int line, int pos) { return new TStatic(text, line, pos); }
    Token new31(String text, int line, int pos) { return new TTclass(text, line, pos); }
    Token new32(String text, int line, int pos) { return new TExtends(text, line, pos); }
    Token new33(String text, int line, int pos) { return new TNew(text, line, pos); }
    Token new34(String text, int line, int pos) { return new TArray(text, line, pos); }
    Token new35(String text, int line, int pos) { return new TList(text, line, pos); }
    Token new36(String text, int line, int pos) { return new TRequire(text, line, pos); }
    Token new37(String text, int line, int pos) { return new TRequireOnce(text, line, pos); }
    Token new38(String text, int line, int pos) { return new TInclude(text, line, pos); }
    Token new39(String text, int line, int pos) { return new TIncludeOnce(text, line, pos); }
    Token new40(String text, int line, int pos) { return new TEcho(text, line, pos); }
    Token new41(String text, int line, int pos) { return new TDeclare(text, line, pos); }
    Token new42(String text, int line, int pos) { return new TPrint(text, line, pos); }
    Token new43(String text, int line, int pos) { return new TBoolean(text, line, pos); }
    Token new44(String text, int line, int pos) { return new THeredocStart(text, line, pos); }
    Token new45(int line, int pos) { return new TPlusEq(line, pos); }
    Token new46(int line, int pos) { return new TMinusEq(line, pos); }
    Token new47(int line, int pos) { return new TStarEq(line, pos); }
    Token new48(int line, int pos) { return new TSlashEq(line, pos); }
    Token new49(int line, int pos) { return new TDotEq(line, pos); }
    Token new50(int line, int pos) { return new TPercEq(line, pos); }
    Token new51(int line, int pos) { return new TCaretEq(line, pos); }
    Token new52(int line, int pos) { return new TAmpEq(line, pos); }
    Token new53(int line, int pos) { return new TBarEq(line, pos); }
    Token new54(int line, int pos) { return new TShLEq(line, pos); }
    Token new55(int line, int pos) { return new TShREq(line, pos); }
    Token new56(int line, int pos) { return new TBopShLeft(line, pos); }
    Token new57(int line, int pos) { return new TBopShRight(line, pos); }
    Token new58(int line, int pos) { return new TPointAssoc(line, pos); }
    Token new59(int line, int pos) { return new TPointElem(line, pos); }
    Token new60(int line, int pos) { return new TCopEq(line, pos); }
    Token new61(int line, int pos) { return new TCopLeq(line, pos); }
    Token new62(int line, int pos) { return new TCopNleq(line, pos); }
    Token new63(int line, int pos) { return new TCopLteq(line, pos); }
    Token new64(int line, int pos) { return new TCopGteq(line, pos); }
    Token new65(int line, int pos) { return new TCopLt(line, pos); }
    Token new66(int line, int pos) { return new TCopGt(line, pos); }
    Token new67(int line, int pos) { return new TCopNeq(line, pos); }
    Token new68(int line, int pos) { return new TCopOr(line, pos); }
    Token new69(int line, int pos) { return new TCopAnd(line, pos); }
    Token new70(String text, int line, int pos) { return new TLopOr(text, line, pos); }
    Token new71(String text, int line, int pos) { return new TLopAnd(text, line, pos); }
    Token new72(String text, int line, int pos) { return new TLopXor(text, line, pos); }
    Token new73(int line, int pos) { return new TExclamation(line, pos); }
    Token new74(int line, int pos) { return new TAmpersand(line, pos); }
    Token new75(int line, int pos) { return new TBar(line, pos); }
    Token new76(int line, int pos) { return new TCaret(line, pos); }
    Token new77(int line, int pos) { return new TTilde(line, pos); }
    Token new78(int line, int pos) { return new TEqual(line, pos); }
    Token new79(int line, int pos) { return new TStar(line, pos); }
    Token new80(int line, int pos) { return new TAt(line, pos); }
    Token new81(int line, int pos) { return new TDiv(line, pos); }
    Token new82(int line, int pos) { return new TMod(line, pos); }
    Token new83(int line, int pos) { return new TPlusPlus(line, pos); }
    Token new84(int line, int pos) { return new TMinusMinus(line, pos); }
    Token new85(int line, int pos) { return new TPlus(line, pos); }
    Token new86(int line, int pos) { return new TMinus(line, pos); }
    Token new87(int line, int pos) { return new TLPar(line, pos); }
    Token new88(int line, int pos) { return new TRPar(line, pos); }
    Token new89(int line, int pos) { return new TLBrace(line, pos); }
    Token new90(int line, int pos) { return new TRBrace(line, pos); }
    Token new91(int line, int pos) { return new TLBracket(line, pos); }
    Token new92(int line, int pos) { return new TRBracket(line, pos); }
    Token new93(int line, int pos) { return new TSemicolon(line, pos); }
    Token new94(int line, int pos) { return new TColon(line, pos); }
    Token new95(int line, int pos) { return new TColoncolon(line, pos); }
    Token new96(int line, int pos) { return new TDot(line, pos); }
    Token new97(int line, int pos) { return new TComma(line, pos); }
    Token new98(int line, int pos) { return new TDollar(line, pos); }
    Token new99(int line, int pos) { return new TQuest(line, pos); }
    Token new100(String text, int line, int pos) { return new TCastInt(text, line, pos); }
    Token new101(String text, int line, int pos) { return new TCastDouble(text, line, pos); }
    Token new102(String text, int line, int pos) { return new TCastString(text, line, pos); }
    Token new103(String text, int line, int pos) { return new TCastArray(text, line, pos); }
    Token new104(String text, int line, int pos) { return new TCastObject(text, line, pos); }
    Token new105(String text, int line, int pos) { return new TCastBool(text, line, pos); }
    Token new106(String text, int line, int pos) { return new TCastUnset(text, line, pos); }
    Token new107(String text, int line, int pos) { return new TFloat(text, line, pos); }
    Token new108(String text, int line, int pos) { return new TInteger(text, line, pos); }
    Token new109(String text, int line, int pos) { return new TVariable(text, line, pos); }
    Token new110(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new111(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new112(String text, int line, int pos) { return new TShortComment(text, line, pos); }
    Token new113(String text, int line, int pos) { return new TLongComment(text, line, pos); }
    Token new114(String text, int line, int pos) { return new TStaticString(text, line, pos); }
    Token new115(int line, int pos) { return new TStringStart(line, pos); }
    Token new116(int line, int pos) { return new TStringEnd(line, pos); }
    Token new117(int line, int pos) { return new TBacktickStart(line, pos); }
    Token new118(int line, int pos) { return new TBacktickEnd(line, pos); }
    Token new119(String text, int line, int pos) { return new TStringToComplexCvar(text, line, pos); }
    Token new120(String text, int line, int pos) { return new THeredocToComplexCvar(text, line, pos); }
    Token new121(String text, int line, int pos) { return new TBacktickToComplexCvar(text, line, pos); }
    Token new122(String text, int line, int pos) { return new TStringVar(text, line, pos); }
    Token new123(String text, int line, int pos) { return new TStringArrayVar(text, line, pos); }
    Token new124(String text, int line, int pos) { return new TStringArrayStatic(text, line, pos); }
    Token new125(String text, int line, int pos) { return new TStringObject(text, line, pos); }
    Token new126(String text, int line, int pos) { return new TStringChunk(text, line, pos); }
    Token new127(String text, int line, int pos) { return new TStringChunkHelper(text, line, pos); }
    Token new128(String text, int line, int pos) { return new THeredocChunk(text, line, pos); }
    Token new129(String text, int line, int pos) { return new THeredocChunkHelper(text, line, pos); }
    Token new130(String text, int line, int pos) { return new TBacktickChunk(text, line, pos); }
    Token new131(String text, int line, int pos) { return new TBacktickChunkHelper(text, line, pos); }
    Token new132(String text, int line, int pos) { return new TStringCvarStart(text, line, pos); }
    Token new133(String text, int line, int pos) { return new TStringCvarEnd(text, line, pos); }
    Token new134(String text, int line, int pos) { return new TStringFromComplexCvar(text, line, pos); }
    Token new135(String text, int line, int pos) { return new THeredocFromComplexCvar(text, line, pos); }
    Token new136(String text, int line, int pos) { return new TBacktickFromComplexCvar(text, line, pos); }
    Token new137(String text, int line, int pos) { return new THeredocEnd(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }


    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable; /* = {
      {
        {
          {0, 59, 1},
          {60, 60, 2},
          {61, 65535, 1},
        },
        {
          {0, 59, 1},
          {60, 60, 3},
          {61, 65535, 1},
        },
        {
          {0, 62, 4},
          {63, 63, 5},
          {64, 65535, 4},
        },
        {
          {0, 62, 4},
          {63, 63, 6},
          {64, 65535, 4},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 8, 7},
          {11, 12, 7},
          {14, 31, 7},
          {33, 60, 7},
          {61, 61, 8},
          {62, 79, 7},
          {80, 80, 9},
          {81, 111, 7},
          {112, 112, 9},
          {113, 65535, 7},
        },
        {
          {0, 60, -7},
          {62, 79, 7},
          {80, 80, 10},
          {81, 111, 7},
          {112, 112, 10},
          {113, 65535, 7},
        },
        {
          {0, 65535, -3},
        },
        {
        },
        {
          {0, 71, 11},
          {72, 72, 12},
          {73, 103, 11},
          {104, 104, 12},
          {105, 65535, 11},
        },
        {
          {0, 71, 11},
          {72, 72, 13},
          {73, 103, 11},
          {104, 104, 13},
          {105, 65535, 11},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 79, 14},
          {80, 80, 15},
          {81, 111, 14},
          {112, 112, 15},
          {113, 65535, 14},
        },
        {
          {0, 79, 14},
          {80, 80, 16},
          {81, 111, 14},
          {112, 112, 16},
          {113, 65535, 14},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 8, 17},
          {11, 12, 17},
          {14, 31, 17},
          {33, 65535, 17},
        },
        {
          {0, 65535, -17},
        },
        {
          {0, 65535, -3},
        },
      },
      {
        {
          {9, 9, 1},
          {10, 10, 2},
          {13, 13, 3},
          {32, 32, 4},
          {33, 33, 5},
          {34, 34, 6},
          {35, 35, 7},
          {36, 36, 8},
          {37, 37, 9},
          {38, 38, 10},
          {39, 39, 11},
          {40, 40, 12},
          {41, 41, 13},
          {42, 42, 14},
          {43, 43, 15},
          {44, 44, 16},
          {45, 45, 17},
          {46, 46, 18},
          {47, 47, 19},
          {48, 48, 20},
          {49, 57, 21},
          {58, 58, 22},
          {59, 59, 23},
          {60, 60, 24},
          {61, 61, 25},
          {62, 62, 26},
          {63, 63, 27},
          {64, 64, 28},
          {65, 65, 29},
          {66, 66, 30},
          {67, 67, 31},
          {68, 68, 32},
          {69, 69, 33},
          {70, 70, 34},
          {71, 71, 35},
          {72, 72, 36},
          {73, 73, 37},
          {74, 75, 36},
          {76, 76, 38},
          {77, 77, 36},
          {78, 78, 39},
          {79, 79, 40},
          {80, 80, 41},
          {81, 81, 36},
          {82, 82, 42},
          {83, 83, 43},
          {84, 84, 44},
          {85, 85, 36},
          {86, 86, 45},
          {87, 87, 46},
          {88, 88, 47},
          {89, 90, 36},
          {91, 91, 48},
          {93, 93, 49},
          {94, 94, 50},
          {95, 95, 51},
          {96, 96, 52},
          {97, 97, 53},
          {98, 98, 54},
          {99, 99, 55},
          {100, 100, 56},
          {101, 101, 57},
          {102, 102, 58},
          {103, 103, 59},
          {104, 104, 60},
          {105, 105, 61},
          {106, 107, 60},
          {108, 108, 62},
          {109, 109, 60},
          {110, 110, 63},
          {111, 111, 64},
          {112, 112, 65},
          {113, 113, 60},
          {114, 114, 66},
          {115, 115, 67},
          {116, 116, 68},
          {117, 117, 60},
          {118, 118, 69},
          {119, 119, 70},
          {120, 120, 71},
          {121, 122, 60},
          {123, 123, 72},
          {124, 124, 73},
          {125, 125, 74},
          {126, 126, 75},
          {127, 255, 76},
        },
        {
          {9, 32, -2},
        },
        {
          {9, 32, -2},
        },
        {
          {9, 9, 1},
          {10, 10, 77},
          {13, 32, -2},
        },
        {
          {9, 32, -2},
        },
        {
          {61, 61, 78},
        },
        {
        },
        {
          {0, 9, 79},
          {10, 10, 80},
          {11, 12, 79},
          {13, 13, 81},
          {14, 65535, 79},
        },
        {
          {65, 90, 82},
          {95, 95, 83},
          {97, 122, 84},
          {127, 255, 85},
        },
        {
          {61, 61, 86},
        },
        {
          {38, 38, 87},
          {61, 61, 88},
        },
        {
          {0, 38, 89},
          {39, 39, 90},
          {40, 91, 89},
          {92, 92, 91},
          {93, 65535, 89},
        },
        {
          {9, 9, 92},
          {32, 32, 92},
          {65, 65, 93},
          {66, 66, 94},
          {68, 68, 95},
          {70, 70, 96},
          {73, 73, 97},
          {79, 79, 98},
          {82, 82, 99},
          {83, 83, 100},
          {85, 85, 101},
          {97, 97, 93},
          {98, 98, 94},
          {100, 100, 95},
          {102, 102, 96},
          {105, 105, 97},
          {111, 111, 98},
          {114, 114, 99},
          {115, 115, 100},
          {117, 117, 101},
        },
        {
        },
        {
          {61, 61, 102},
        },
        {
          {43, 43, 103},
          {61, 61, 104},
        },
        {
        },
        {
          {45, 45, 105},
          {61, 61, 106},
          {62, 62, 107},
        },
        {
          {48, 57, 108},
          {61, 61, 109},
        },
        {
          {42, 42, 110},
          {47, 47, 111},
          {61, 61, 112},
        },
        {
          {46, 46, 113},
          {48, 57, 21},
          {69, 69, 114},
          {88, 88, 115},
          {101, 101, 116},
          {120, 120, 115},
        },
        {
          {46, 69, -22},
          {101, 101, 116},
        },
        {
          {58, 58, 117},
        },
        {
        },
        {
          {60, 60, 118},
          {61, 61, 119},
        },
        {
          {61, 61, 120},
          {62, 62, 121},
        },
        {
          {61, 61, 122},
          {62, 62, 123},
        },
        {
          {62, 62, 124},
        },
        {
        },
        {
          {48, 57, 125},
          {65, 77, 126},
          {78, 78, 127},
          {79, 81, 126},
          {82, 82, 128},
          {83, 83, 129},
          {84, 90, 126},
          {95, 95, 130},
          {97, 109, 131},
          {110, 110, 132},
          {111, 113, 131},
          {114, 114, 133},
          {115, 115, 134},
          {116, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 81, 126},
          {82, 82, 136},
          {83, 90, 126},
          {95, 95, 130},
          {97, 113, 131},
          {114, 114, 137},
          {115, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 65, 138},
          {66, 69, 126},
          {70, 70, 139},
          {71, 75, 126},
          {76, 76, 140},
          {77, 78, 126},
          {79, 79, 141},
          {80, 90, 126},
          {95, 95, 130},
          {97, 97, 142},
          {98, 101, 131},
          {102, 102, 143},
          {103, 107, 131},
          {108, 108, 144},
          {109, 110, 131},
          {111, 111, 145},
          {112, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 68, 126},
          {69, 69, 146},
          {70, 78, 126},
          {79, 79, 147},
          {80, 95, -33},
          {97, 100, 131},
          {101, 101, 148},
          {102, 110, 131},
          {111, 111, 149},
          {112, 255, -33},
        },
        {
          {48, 57, 125},
          {65, 66, 126},
          {67, 67, 150},
          {68, 75, 126},
          {76, 76, 151},
          {77, 77, 126},
          {78, 78, 152},
          {79, 87, 126},
          {88, 88, 153},
          {89, 90, 126},
          {95, 95, 130},
          {97, 98, 131},
          {99, 99, 154},
          {100, 107, 131},
          {108, 108, 155},
          {109, 109, 131},
          {110, 110, 156},
          {111, 119, 131},
          {120, 120, 157},
          {121, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 65, 158},
          {66, 78, 126},
          {79, 79, 159},
          {80, 84, 126},
          {85, 85, 160},
          {86, 90, 126},
          {95, 95, 130},
          {97, 97, 161},
          {98, 110, 131},
          {111, 111, 162},
          {112, 116, 131},
          {117, 117, 163},
          {118, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 75, 126},
          {76, 76, 164},
          {77, 90, 126},
          {95, 95, 130},
          {97, 107, 131},
          {108, 108, 165},
          {109, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 90, 126},
          {95, 95, 130},
          {97, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 69, 126},
          {70, 70, 166},
          {71, 77, 126},
          {78, 78, 167},
          {79, 90, 126},
          {95, 95, 130},
          {97, 101, 131},
          {102, 102, 168},
          {103, 109, 131},
          {110, 110, 169},
          {111, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 72, 126},
          {73, 73, 170},
          {74, 90, 126},
          {95, 95, 130},
          {97, 104, 131},
          {105, 105, 171},
          {106, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 68, -34},
          {69, 69, 172},
          {70, 90, 126},
          {95, 100, -34},
          {101, 101, 173},
          {102, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 81, -32},
          {82, 82, 174},
          {83, 113, -32},
          {114, 114, 175},
          {115, 255, -32},
        },
        {
          {48, 81, -32},
          {82, 82, 176},
          {83, 113, -32},
          {114, 114, 177},
          {115, 255, -32},
        },
        {
          {48, 68, -34},
          {69, 69, 178},
          {70, 100, -41},
          {101, 101, 179},
          {102, 255, -41},
        },
        {
          {48, 57, 125},
          {65, 83, 126},
          {84, 84, 180},
          {85, 86, 126},
          {87, 87, 181},
          {88, 90, 126},
          {95, 95, 130},
          {97, 115, 131},
          {116, 116, 182},
          {117, 118, 131},
          {119, 119, 183},
          {120, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 81, -32},
          {82, 82, 184},
          {83, 113, -32},
          {114, 114, 185},
          {115, 255, -32},
        },
        {
          {48, 57, 125},
          {65, 65, 186},
          {66, 90, 126},
          {95, 95, 130},
          {97, 97, 187},
          {98, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 71, 126},
          {72, 72, 188},
          {73, 90, 126},
          {95, 95, 130},
          {97, 103, 131},
          {104, 104, 189},
          {105, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 57, 125},
          {65, 78, 126},
          {79, 79, 190},
          {80, 95, -33},
          {97, 110, 131},
          {111, 111, 191},
          {112, 255, -33},
        },
        {
        },
        {
        },
        {
          {61, 61, 192},
        },
        {
          {48, 255, -38},
        },
        {
        },
        {
          {48, 255, -31},
        },
        {
          {48, 255, -32},
        },
        {
          {48, 255, -33},
        },
        {
          {48, 255, -34},
        },
        {
          {48, 255, -35},
        },
        {
          {48, 255, -36},
        },
        {
          {48, 255, -37},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -39},
        },
        {
          {48, 255, -40},
        },
        {
          {48, 255, -41},
        },
        {
          {48, 255, -42},
        },
        {
          {48, 255, -43},
        },
        {
          {48, 255, -44},
        },
        {
          {48, 255, -45},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -48},
        },
        {
          {48, 255, -49},
        },
        {
        },
        {
          {61, 61, 193},
          {124, 124, 194},
        },
        {
        },
        {
        },
        {
          {48, 255, -38},
        },
        {
          {9, 32, -2},
        },
        {
          {61, 61, 195},
        },
        {
          {0, 65535, -9},
        },
        {
        },
        {
          {10, 10, 196},
        },
        {
          {48, 57, 197},
          {65, 90, 198},
          {95, 95, 199},
          {97, 122, 200},
          {127, 255, 201},
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
        },
        {
        },
        {
        },
        {
          {0, 65535, -13},
        },
        {
        },
        {
          {0, 65535, 202},
        },
        {
          {9, 117, -14},
        },
        {
          {82, 82, 203},
          {114, 114, 203},
        },
        {
          {79, 79, 204},
          {111, 111, 204},
        },
        {
          {79, 79, 205},
          {111, 111, 205},
        },
        {
          {76, 76, 206},
          {108, 108, 206},
        },
        {
          {78, 78, 207},
          {110, 110, 207},
        },
        {
          {66, 66, 208},
          {98, 98, 208},
        },
        {
          {69, 69, 209},
          {101, 101, 209},
        },
        {
          {84, 84, 210},
          {116, 116, 210},
        },
        {
          {78, 78, 211},
          {110, 110, 211},
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
          {48, 57, 108},
          {69, 69, 212},
          {101, 101, 213},
        },
        {
        },
        {
          {0, 41, 214},
          {42, 42, 215},
          {43, 65535, 214},
        },
        {
          {0, 9, 216},
          {10, 10, 217},
          {11, 12, 216},
          {13, 13, 218},
          {14, 65535, 216},
        },
        {
        },
        {
          {48, 101, -110},
        },
        {
          {43, 43, 219},
          {45, 45, 220},
          {48, 57, 221},
        },
        {
          {48, 57, 222},
          {65, 70, 223},
          {97, 102, 224},
        },
        {
          {43, 57, -116},
        },
        {
        },
        {
          {60, 60, 225},
          {61, 61, 226},
        },
        {
        },
        {
          {61, 61, 227},
        },
        {
        },
        {
        },
        {
          {61, 61, 228},
        },
        {
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 57, 125},
          {65, 67, 126},
          {68, 68, 229},
          {69, 90, 126},
          {95, 95, 130},
          {97, 99, 131},
          {100, 100, 230},
          {101, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 81, -32},
          {82, 82, 231},
          {83, 113, -32},
          {114, 114, 232},
          {115, 255, -32},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -129},
        },
        {
          {48, 255, -130},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 68, -34},
          {69, 69, 233},
          {70, 100, -41},
          {101, 101, 234},
          {102, 255, -41},
        },
        {
          {48, 255, -138},
        },
        {
          {48, 57, 125},
          {65, 82, 126},
          {83, 83, 235},
          {84, 95, -31},
          {97, 114, 131},
          {115, 115, 236},
          {116, 255, -31},
        },
        {
          {48, 57, 125},
          {65, 84, 126},
          {85, 85, 237},
          {86, 95, -36},
          {97, 116, 131},
          {117, 117, 238},
          {118, 255, -36},
        },
        {
          {48, 57, 125},
          {65, 65, 239},
          {66, 95, -47},
          {97, 97, 240},
          {98, 255, -47},
        },
        {
          {48, 77, -31},
          {78, 78, 241},
          {79, 95, -39},
          {97, 109, 131},
          {110, 110, 242},
          {111, 255, -39},
        },
        {
          {48, 255, -140},
        },
        {
          {48, 255, -141},
        },
        {
          {48, 255, -142},
        },
        {
          {48, 255, -143},
        },
        {
          {48, 66, -35},
          {67, 67, 243},
          {68, 69, 126},
          {70, 70, 244},
          {71, 90, 126},
          {95, 98, -35},
          {99, 99, 245},
          {100, 101, 131},
          {102, 102, 246},
          {103, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -148},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 71, -48},
          {72, 72, 247},
          {73, 103, -48},
          {104, 104, 248},
          {105, 255, -48},
        },
        {
          {48, 82, -140},
          {83, 83, 249},
          {84, 114, -140},
          {115, 115, 250},
          {116, 255, -31},
        },
        {
          {48, 67, -129},
          {68, 68, 251},
          {69, 99, -129},
          {100, 100, 252},
          {101, 255, -129},
        },
        {
          {48, 72, -40},
          {73, 73, 253},
          {74, 83, 126},
          {84, 84, 254},
          {85, 90, 126},
          {95, 104, -40},
          {105, 105, 255},
          {106, 115, 131},
          {116, 116, 256},
          {117, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -152},
        },
        {
          {48, 255, -153},
        },
        {
          {48, 255, -154},
        },
        {
          {48, 255, -155},
        },
        {
          {48, 75, -37},
          {76, 76, 257},
          {77, 107, -37},
          {108, 108, 258},
          {109, 255, -37},
        },
        {
          {48, 81, -32},
          {82, 82, 259},
          {83, 113, -32},
          {114, 114, 260},
          {115, 255, -32},
        },
        {
          {48, 77, -31},
          {78, 78, 261},
          {79, 109, -143},
          {110, 110, 262},
          {111, 255, -39},
        },
        {
          {48, 255, -160},
        },
        {
          {48, 255, -161},
        },
        {
          {48, 255, -162},
        },
        {
          {48, 78, -49},
          {79, 79, 263},
          {80, 110, -49},
          {111, 111, 264},
          {112, 255, -33},
        },
        {
          {48, 255, -166},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 66, -35},
          {67, 67, 265},
          {68, 90, 126},
          {95, 98, -35},
          {99, 99, 266},
          {100, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -169},
        },
        {
          {48, 82, -140},
          {83, 83, 267},
          {84, 114, -140},
          {115, 115, 268},
          {116, 255, -31},
        },
        {
          {48, 255, -172},
        },
        {
          {48, 57, 125},
          {65, 86, 126},
          {87, 87, 269},
          {88, 95, -45},
          {97, 118, 131},
          {119, 119, 270},
          {120, 255, -45},
        },
        {
          {48, 255, -174},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 72, -40},
          {73, 73, 271},
          {74, 104, -40},
          {105, 105, 272},
          {106, 255, -40},
        },
        {
          {48, 255, -178},
        },
        {
          {48, 57, 125},
          {65, 80, 126},
          {81, 81, 273},
          {82, 83, 126},
          {84, 84, 274},
          {85, 95, -155},
          {97, 112, 131},
          {113, 113, 275},
          {114, 115, 131},
          {116, 116, 276},
          {117, 255, -155},
        },
        {
          {48, 255, -180},
        },
        {
          {48, 57, 125},
          {65, 65, 277},
          {66, 95, -47},
          {97, 97, 278},
          {98, 255, -47},
        },
        {
          {48, 72, -40},
          {73, 73, 279},
          {74, 104, -40},
          {105, 105, 280},
          {106, 255, -40},
        },
        {
          {48, 255, -182},
        },
        {
          {48, 255, -183},
        },
        {
          {48, 84, -141},
          {85, 85, 281},
          {86, 116, -141},
          {117, 117, 282},
          {118, 255, -36},
        },
        {
          {48, 255, -186},
        },
        {
          {48, 81, -32},
          {82, 82, 283},
          {83, 113, -32},
          {114, 114, 284},
          {115, 255, -32},
        },
        {
          {48, 255, -188},
        },
        {
          {48, 72, -40},
          {73, 73, 285},
          {74, 104, -40},
          {105, 105, 286},
          {106, 255, -40},
        },
        {
          {48, 255, -190},
        },
        {
          {48, 81, -32},
          {82, 82, 287},
          {83, 113, -32},
          {114, 114, 288},
          {115, 255, -32},
        },
        {
          {48, 255, -192},
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
          {48, 255, -84},
        },
        {
          {0, 65535, -13},
        },
        {
          {82, 82, 289},
          {114, 114, 289},
        },
        {
          {79, 79, 290},
          {111, 111, 290},
        },
        {
          {85, 85, 291},
          {117, 117, 291},
        },
        {
          {79, 79, 292},
          {111, 111, 292},
        },
        {
          {84, 84, 293},
          {116, 116, 293},
        },
        {
          {74, 74, 294},
          {106, 106, 294},
        },
        {
          {65, 65, 295},
          {97, 97, 295},
        },
        {
          {82, 82, 296},
          {114, 114, 296},
        },
        {
          {83, 83, 297},
          {115, 115, 297},
        },
        {
          {43, 43, 298},
          {45, 45, 299},
          {48, 57, 300},
        },
        {
          {43, 57, -214},
        },
        {
          {0, 65535, -112},
        },
        {
          {0, 41, 301},
          {42, 42, 215},
          {43, 46, 301},
          {47, 47, 302},
          {48, 65535, 301},
        },
        {
          {0, 65535, -113},
        },
        {
        },
        {
          {10, 10, 303},
        },
        {
          {48, 57, 221},
        },
        {
          {48, 57, 221},
        },
        {
          {48, 57, 221},
        },
        {
          {48, 102, -117},
        },
        {
          {48, 102, -117},
        },
        {
          {48, 102, -117},
        },
        {
          {65, 90, 304},
          {95, 95, 305},
          {97, 122, 306},
          {127, 255, 307},
        },
        {
        },
        {
        },
        {
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 57, 125},
          {65, 65, 308},
          {66, 95, -47},
          {97, 97, 309},
          {98, 255, -47},
        },
        {
          {48, 255, -233},
        },
        {
          {48, 57, 125},
          {65, 65, 310},
          {66, 95, -47},
          {97, 97, 311},
          {98, 255, -47},
        },
        {
          {48, 255, -235},
        },
        {
          {48, 68, -34},
          {69, 69, 312},
          {70, 100, -41},
          {101, 101, 313},
          {102, 255, -41},
        },
        {
          {48, 255, -237},
        },
        {
          {48, 77, -31},
          {78, 78, 314},
          {79, 109, -143},
          {110, 110, 315},
          {111, 255, -39},
        },
        {
          {48, 255, -239},
        },
        {
          {48, 82, -140},
          {83, 83, 316},
          {84, 114, -140},
          {115, 115, 317},
          {116, 255, -31},
        },
        {
          {48, 255, -241},
        },
        {
          {48, 83, -45},
          {84, 84, 318},
          {85, 95, -155},
          {97, 115, 131},
          {116, 116, 319},
          {117, 255, -155},
        },
        {
          {48, 255, -243},
        },
        {
          {48, 75, -37},
          {76, 76, 320},
          {77, 107, -37},
          {108, 108, 321},
          {109, 255, -37},
        },
        {
          {48, 57, 125},
          {65, 65, 322},
          {66, 95, -47},
          {97, 97, 323},
          {98, 255, -47},
        },
        {
          {48, 255, -245},
        },
        {
          {48, 255, -246},
        },
        {
          {48, 78, -49},
          {79, 79, 324},
          {80, 110, -49},
          {111, 111, 325},
          {112, 255, -33},
        },
        {
          {48, 255, -249},
        },
        {
          {48, 68, -34},
          {69, 69, 326},
          {70, 100, -41},
          {101, 101, 327},
          {102, 255, -41},
        },
        {
          {48, 255, -251},
        },
        {
          {48, 69, -39},
          {70, 70, 328},
          {71, 72, 126},
          {73, 73, 329},
          {74, 82, 126},
          {83, 83, 330},
          {84, 86, 126},
          {87, 87, 331},
          {88, 95, -45},
          {97, 101, 131},
          {102, 102, 332},
          {103, 104, 131},
          {105, 105, 333},
          {106, 114, 131},
          {115, 115, 334},
          {116, 118, 131},
          {119, 119, 335},
          {120, 255, -45},
        },
        {
          {48, 255, -253},
        },
        {
          {48, 83, -45},
          {84, 84, 336},
          {85, 115, -243},
          {116, 116, 337},
          {117, 255, -155},
        },
        {
          {48, 68, -34},
          {69, 69, 338},
          {70, 100, -41},
          {101, 101, 339},
          {102, 255, -41},
        },
        {
          {48, 255, -255},
        },
        {
          {48, 255, -256},
        },
        {
          {48, 82, -140},
          {83, 83, 340},
          {84, 114, -140},
          {115, 115, 341},
          {116, 255, -31},
        },
        {
          {48, 255, -259},
        },
        {
          {48, 68, -34},
          {69, 69, 342},
          {70, 100, -41},
          {101, 101, 343},
          {102, 255, -41},
        },
        {
          {48, 255, -261},
        },
        {
          {48, 66, -35},
          {67, 67, 344},
          {68, 98, -169},
          {99, 99, 345},
          {100, 255, -169},
        },
        {
          {48, 255, -263},
        },
        {
          {48, 57, 125},
          {65, 65, 126},
          {66, 66, 346},
          {67, 90, 126},
          {95, 95, 130},
          {97, 97, 131},
          {98, 98, 347},
          {99, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -265},
        },
        {
          {48, 75, -37},
          {76, 76, 348},
          {77, 107, -37},
          {108, 108, 349},
          {109, 255, -37},
        },
        {
          {48, 255, -267},
        },
        {
          {48, 83, -45},
          {84, 84, 350},
          {85, 115, -243},
          {116, 116, 351},
          {117, 255, -155},
        },
        {
          {48, 255, -269},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 77, -31},
          {78, 78, 352},
          {79, 109, -143},
          {110, 110, 353},
          {111, 255, -39},
        },
        {
          {48, 255, -273},
        },
        {
          {48, 84, -141},
          {85, 85, 354},
          {86, 116, -141},
          {117, 117, 355},
          {118, 255, -36},
        },
        {
          {48, 84, -141},
          {85, 85, 356},
          {86, 116, -141},
          {117, 117, 357},
          {118, 255, -36},
        },
        {
          {48, 255, -275},
        },
        {
          {48, 255, -276},
        },
        {
          {48, 83, -45},
          {84, 84, 358},
          {85, 115, -243},
          {116, 116, 359},
          {117, 255, -155},
        },
        {
          {48, 255, -279},
        },
        {
          {48, 83, -45},
          {84, 84, 360},
          {85, 115, -243},
          {116, 116, 361},
          {117, 255, -155},
        },
        {
          {48, 255, -281},
        },
        {
          {48, 68, -34},
          {69, 69, 362},
          {70, 100, -41},
          {101, 101, 363},
          {102, 255, -41},
        },
        {
          {48, 255, -283},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 75, -37},
          {76, 76, 364},
          {77, 107, -37},
          {108, 108, 365},
          {109, 255, -37},
        },
        {
          {48, 255, -287},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {65, 65, 366},
          {97, 97, 366},
        },
        {
          {76, 76, 367},
          {108, 108, 367},
        },
        {
          {66, 66, 368},
          {98, 98, 368},
        },
        {
          {65, 65, 369},
          {97, 97, 369},
        },
        {
          {9, 9, 370},
          {32, 32, 370},
          {41, 41, 371},
          {69, 69, 372},
          {101, 101, 372},
        },
        {
          {69, 69, 373},
          {101, 101, 373},
        },
        {
          {76, 76, 374},
          {108, 108, 374},
        },
        {
          {73, 73, 375},
          {105, 105, 375},
        },
        {
          {69, 69, 376},
          {101, 101, 376},
        },
        {
          {48, 57, 300},
        },
        {
          {48, 57, 300},
        },
        {
          {48, 57, 300},
        },
        {
          {0, 41, 377},
          {42, 42, 378},
          {43, 65535, 377},
        },
        {
        },
        {
        },
        {
          {48, 57, 379},
          {65, 90, 380},
          {95, 95, 381},
          {97, 122, 382},
          {127, 255, 383},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 57, 125},
          {65, 88, 126},
          {89, 89, 384},
          {90, 90, 126},
          {95, 95, 130},
          {97, 120, 131},
          {121, 121, 385},
          {122, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -310},
        },
        {
          {48, 57, 125},
          {65, 74, 126},
          {75, 75, 386},
          {76, 90, 126},
          {95, 95, 130},
          {97, 106, 131},
          {107, 107, 387},
          {108, 122, 131},
          {127, 255, 135},
        },
        {
          {48, 255, -312},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 66, -35},
          {67, 67, 388},
          {68, 98, -169},
          {99, 99, 389},
          {100, 255, -169},
        },
        {
          {48, 255, -316},
        },
        {
          {48, 82, -140},
          {83, 83, 390},
          {84, 114, -140},
          {115, 115, 391},
          {116, 255, -31},
        },
        {
          {48, 255, -318},
        },
        {
          {48, 72, -40},
          {73, 73, 392},
          {74, 104, -40},
          {105, 105, 393},
          {106, 255, -40},
        },
        {
          {48, 255, -320},
        },
        {
          {48, 57, 125},
          {65, 65, 394},
          {66, 95, -47},
          {97, 97, 395},
          {98, 255, -47},
        },
        {
          {48, 255, -322},
        },
        {
          {48, 84, -141},
          {85, 85, 396},
          {86, 116, -141},
          {117, 117, 397},
          {118, 255, -36},
        },
        {
          {48, 255, -324},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {9, 9, 398},
          {10, 10, 399},
          {13, 13, 400},
          {32, 32, 401},
          {48, 57, 125},
          {58, 58, 402},
          {65, 72, 126},
          {73, 73, 403},
          {74, 104, -40},
          {105, 105, 404},
          {106, 255, -40},
        },
        {
          {9, 255, -328},
        },
        {
          {48, 78, -49},
          {79, 79, 405},
          {80, 110, -49},
          {111, 111, 406},
          {112, 255, -33},
        },
        {
          {48, 69, -39},
          {70, 70, 407},
          {71, 95, -148},
          {97, 101, 131},
          {102, 102, 408},
          {103, 255, -148},
        },
        {
          {48, 86, -174},
          {87, 87, 409},
          {88, 118, -174},
          {119, 119, 410},
          {120, 255, -45},
        },
        {
          {48, 71, -48},
          {72, 72, 411},
          {73, 103, -48},
          {104, 104, 412},
          {105, 255, -48},
        },
        {
          {48, 255, -330},
        },
        {
          {48, 255, -331},
        },
        {
          {48, 255, -332},
        },
        {
          {48, 255, -333},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 77, -31},
          {78, 78, 413},
          {79, 109, -143},
          {110, 110, 414},
          {111, 255, -39},
        },
        {
          {48, 255, -340},
        },
        {
          {48, 68, -34},
          {69, 69, 415},
          {70, 100, -41},
          {101, 101, 416},
          {102, 255, -41},
        },
        {
          {48, 255, -342},
        },
        {
          {48, 57, 125},
          {65, 65, 417},
          {66, 95, -47},
          {97, 97, 418},
          {98, 255, -47},
        },
        {
          {48, 255, -344},
        },
        {
          {48, 83, -45},
          {84, 84, 419},
          {85, 115, -243},
          {116, 116, 420},
          {117, 255, -155},
        },
        {
          {48, 255, -346},
        },
        {
          {48, 57, 125},
          {65, 65, 421},
          {66, 95, -47},
          {97, 97, 422},
          {98, 255, -47},
        },
        {
          {48, 255, -348},
        },
        {
          {48, 84, -141},
          {85, 85, 423},
          {86, 116, -141},
          {117, 117, 424},
          {118, 255, -36},
        },
        {
          {48, 255, -350},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 83, -45},
          {84, 84, 425},
          {85, 115, -243},
          {116, 116, 426},
          {117, 255, -155},
        },
        {
          {48, 255, -354},
        },
        {
          {48, 72, -40},
          {73, 73, 427},
          {74, 104, -40},
          {105, 105, 428},
          {106, 255, -40},
        },
        {
          {48, 255, -356},
        },
        {
          {48, 81, -32},
          {82, 82, 429},
          {83, 113, -32},
          {114, 114, 430},
          {115, 255, -32},
        },
        {
          {48, 255, -358},
        },
        {
          {48, 72, -40},
          {73, 73, 431},
          {74, 104, -40},
          {105, 105, 432},
          {106, 255, -40},
        },
        {
          {48, 255, -360},
        },
        {
          {48, 66, -35},
          {67, 67, 433},
          {68, 98, -169},
          {99, 99, 434},
          {100, 255, -169},
        },
        {
          {48, 255, -362},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 68, -34},
          {69, 69, 435},
          {70, 100, -41},
          {101, 101, 436},
          {102, 255, -41},
        },
        {
          {48, 255, -366},
        },
        {
          {89, 89, 437},
          {121, 121, 437},
        },
        {
          {9, 9, 438},
          {32, 32, 438},
          {41, 41, 439},
          {69, 69, 440},
          {101, 101, 440},
        },
        {
          {76, 76, 441},
          {108, 108, 441},
        },
        {
          {84, 84, 442},
          {116, 116, 442},
        },
        {
          {9, 41, -295},
        },
        {
        },
        {
          {71, 71, 443},
          {103, 103, 443},
        },
        {
          {67, 67, 444},
          {99, 99, 444},
        },
        {
          {9, 9, 445},
          {32, 32, 445},
          {41, 41, 446},
        },
        {
          {78, 78, 447},
          {110, 110, 447},
        },
        {
          {84, 84, 448},
          {116, 116, 448},
        },
        {
          {0, 65535, -303},
        },
        {
          {0, 41, 301},
          {42, 42, 378},
          {43, 65535, -217},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -306},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 83, -45},
          {84, 84, 449},
          {85, 115, -243},
          {116, 116, 450},
          {117, 255, -155},
        },
        {
          {48, 255, -390},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 77, -31},
          {78, 78, 451},
          {79, 109, -143},
          {110, 110, 452},
          {111, 255, -39},
        },
        {
          {48, 255, -394},
        },
        {
          {48, 81, -32},
          {82, 82, 453},
          {83, 113, -32},
          {114, 114, 454},
          {115, 255, -32},
        },
        {
          {48, 255, -396},
        },
        {
          {48, 75, -37},
          {76, 76, 455},
          {77, 107, -37},
          {108, 108, 456},
          {109, 255, -37},
        },
        {
          {48, 255, -398},
        },
        {
          {9, 32, -328},
          {58, 58, 402},
        },
        {
          {9, 58, -400},
        },
        {
          {9, 9, 398},
          {10, 10, 457},
          {13, 58, -400},
        },
        {
          {9, 58, -400},
        },
        {
        },
        {
          {48, 69, -39},
          {70, 70, 458},
          {71, 101, -331},
          {102, 102, 459},
          {103, 255, -148},
        },
        {
          {48, 255, -405},
        },
        {
          {48, 81, -32},
          {82, 82, 460},
          {83, 113, -32},
          {114, 114, 461},
          {115, 255, -32},
        },
        {
          {48, 255, -407},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 72, -40},
          {73, 73, 462},
          {74, 104, -40},
          {105, 105, 463},
          {106, 255, -40},
        },
        {
          {48, 255, -411},
        },
        {
          {48, 72, -40},
          {73, 73, 464},
          {74, 104, -40},
          {105, 105, 465},
          {106, 255, -40},
        },
        {
          {48, 255, -413},
        },
        {
          {48, 67, -129},
          {68, 68, 466},
          {69, 99, -129},
          {100, 100, 467},
          {101, 255, -129},
        },
        {
          {48, 255, -415},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 66, -35},
          {67, 67, 468},
          {68, 98, -169},
          {99, 99, 469},
          {100, 255, -169},
        },
        {
          {48, 255, -419},
        },
        {
          {48, 72, -40},
          {73, 73, 470},
          {74, 104, -40},
          {105, 105, 471},
          {106, 255, -40},
        },
        {
          {48, 255, -421},
        },
        {
          {48, 75, -37},
          {76, 76, 472},
          {77, 107, -37},
          {108, 108, 473},
          {109, 255, -37},
        },
        {
          {48, 255, -423},
        },
        {
          {48, 67, -129},
          {68, 68, 474},
          {69, 99, -129},
          {100, 100, 475},
          {101, 255, -129},
        },
        {
          {48, 255, -425},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 81, -32},
          {82, 82, 476},
          {83, 113, -32},
          {114, 114, 477},
          {115, 255, -32},
        },
        {
          {48, 255, -429},
        },
        {
          {48, 77, -31},
          {78, 78, 478},
          {79, 109, -143},
          {110, 110, 479},
          {111, 255, -39},
        },
        {
          {48, 255, -431},
        },
        {
          {48, 66, -35},
          {67, 67, 480},
          {68, 98, -169},
          {99, 99, 481},
          {100, 255, -169},
        },
        {
          {48, 255, -433},
        },
        {
          {48, 71, -48},
          {72, 72, 482},
          {73, 103, -48},
          {104, 104, 483},
          {105, 255, -48},
        },
        {
          {48, 255, -435},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {9, 9, 484},
          {32, 32, 484},
          {41, 41, 485},
        },
        {
          {9, 41, -369},
        },
        {
        },
        {
          {65, 65, 486},
          {97, 97, 486},
        },
        {
          {69, 69, 487},
          {101, 101, 487},
        },
        {
          {9, 41, -376},
        },
        {
          {69, 69, 488},
          {101, 101, 488},
        },
        {
          {84, 84, 489},
          {116, 116, 489},
        },
        {
          {9, 41, -376},
        },
        {
        },
        {
          {71, 71, 490},
          {103, 103, 490},
        },
        {
          {9, 9, 491},
          {32, 32, 491},
          {41, 41, 492},
        },
        {
          {48, 72, -40},
          {73, 73, 493},
          {74, 104, -40},
          {105, 105, 494},
          {106, 255, -40},
        },
        {
          {48, 255, -451},
        },
        {
          {48, 84, -141},
          {85, 85, 495},
          {86, 116, -141},
          {117, 117, 496},
          {118, 255, -36},
        },
        {
          {48, 255, -453},
        },
        {
          {48, 68, -34},
          {69, 69, 497},
          {70, 100, -41},
          {101, 101, 498},
          {102, 255, -41},
        },
        {
          {48, 255, -455},
        },
        {
          {48, 83, -45},
          {84, 84, 499},
          {85, 115, -243},
          {116, 116, 500},
          {117, 255, -155},
        },
        {
          {48, 255, -457},
        },
        {
          {9, 58, -400},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 68, -34},
          {69, 69, 501},
          {70, 100, -41},
          {101, 101, 502},
          {102, 255, -41},
        },
        {
          {48, 255, -462},
        },
        {
          {48, 83, -45},
          {84, 84, 503},
          {85, 115, -243},
          {116, 116, 504},
          {117, 255, -155},
        },
        {
          {48, 255, -464},
        },
        {
          {48, 75, -37},
          {76, 76, 505},
          {77, 107, -37},
          {108, 108, 506},
          {109, 255, -37},
        },
        {
          {48, 255, -466},
        },
        {
          {48, 82, -140},
          {83, 83, 507},
          {84, 114, -140},
          {115, 115, 508},
          {116, 255, -31},
        },
        {
          {48, 255, -468},
        },
        {
          {48, 71, -48},
          {72, 72, 509},
          {73, 103, -48},
          {104, 104, 510},
          {105, 255, -48},
        },
        {
          {48, 255, -470},
        },
        {
          {48, 78, -49},
          {79, 79, 511},
          {80, 110, -49},
          {111, 111, 512},
          {112, 255, -33},
        },
        {
          {48, 255, -472},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 68, -34},
          {69, 69, 513},
          {70, 100, -41},
          {101, 101, 514},
          {102, 255, -41},
        },
        {
          {48, 255, -476},
        },
        {
          {48, 68, -34},
          {69, 69, 515},
          {70, 100, -41},
          {101, 101, 516},
          {102, 255, -41},
        },
        {
          {48, 255, -478},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {9, 41, -439},
        },
        {
        },
        {
          {78, 78, 517},
          {110, 110, 517},
        },
        {
          {9, 41, -376},
        },
        {
          {82, 82, 518},
          {114, 114, 518},
        },
        {
          {9, 9, 519},
          {32, 32, 519},
          {41, 41, 520},
        },
        {
          {9, 9, 521},
          {32, 32, 521},
          {41, 41, 522},
        },
        {
          {9, 41, -450},
        },
        {
        },
        {
          {48, 78, -49},
          {79, 79, 523},
          {80, 110, -49},
          {111, 111, 524},
          {112, 255, -33},
        },
        {
          {48, 255, -495},
        },
        {
          {48, 68, -34},
          {69, 69, 525},
          {70, 100, -41},
          {101, 101, 526},
          {102, 255, -41},
        },
        {
          {48, 255, -497},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 57, 125},
          {65, 65, 527},
          {66, 95, -47},
          {97, 97, 528},
          {98, 255, -47},
        },
        {
          {48, 255, -503},
        },
        {
          {48, 66, -35},
          {67, 67, 529},
          {68, 98, -169},
          {99, 99, 530},
          {100, 255, -169},
        },
        {
          {48, 255, -505},
        },
        {
          {48, 68, -34},
          {69, 69, 531},
          {70, 100, -41},
          {101, 101, 532},
          {102, 255, -41},
        },
        {
          {48, 255, -507},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 77, -31},
          {78, 78, 533},
          {79, 109, -143},
          {110, 110, 534},
          {111, 255, -39},
        },
        {
          {48, 255, -513},
        },
        {
          {48, 90, -38},
          {95, 95, 535},
          {97, 255, -38},
        },
        {
          {48, 255, -515},
        },
        {
          {48, 90, -38},
          {95, 95, 536},
          {97, 255, -38},
        },
        {
          {48, 255, -517},
        },
        {
          {9, 41, -369},
        },
        {
          {9, 41, -295},
        },
        {
          {9, 41, -491},
        },
        {
        },
        {
          {9, 41, -492},
        },
        {
        },
        {
          {48, 77, -31},
          {78, 78, 537},
          {79, 109, -143},
          {110, 110, 538},
          {111, 255, -39},
        },
        {
          {48, 255, -525},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 66, -35},
          {67, 67, 539},
          {68, 98, -169},
          {99, 99, 540},
          {100, 255, -169},
        },
        {
          {48, 255, -529},
        },
        {
          {48, 71, -48},
          {72, 72, 541},
          {73, 103, -48},
          {104, 104, 542},
          {105, 255, -48},
        },
        {
          {48, 255, -531},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 78, -49},
          {79, 79, 543},
          {80, 110, -49},
          {111, 111, 544},
          {112, 255, -33},
        },
        {
          {48, 78, -49},
          {79, 79, 545},
          {80, 110, -49},
          {111, 111, 546},
          {112, 255, -33},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 71, -48},
          {72, 72, 547},
          {73, 103, -48},
          {104, 104, 548},
          {105, 255, -48},
        },
        {
          {48, 255, -541},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 77, -31},
          {78, 78, 549},
          {79, 109, -143},
          {110, 110, 550},
          {111, 255, -39},
        },
        {
          {48, 255, -545},
        },
        {
          {48, 77, -31},
          {78, 78, 551},
          {79, 109, -143},
          {110, 110, 552},
          {111, 255, -39},
        },
        {
          {48, 255, -547},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 66, -35},
          {67, 67, 553},
          {68, 98, -169},
          {99, 99, 554},
          {100, 255, -169},
        },
        {
          {48, 255, -551},
        },
        {
          {48, 66, -35},
          {67, 67, 555},
          {68, 98, -169},
          {99, 99, 556},
          {100, 255, -169},
        },
        {
          {48, 255, -553},
        },
        {
          {48, 68, -34},
          {69, 69, 557},
          {70, 100, -41},
          {101, 101, 558},
          {102, 255, -41},
        },
        {
          {48, 255, -555},
        },
        {
          {48, 68, -34},
          {69, 69, 559},
          {70, 100, -41},
          {101, 101, 560},
          {102, 255, -41},
        },
        {
          {48, 255, -557},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
        {
          {48, 255, -38},
        },
      },
      {
        {
          {0, 33, 1},
          {34, 34, 2},
          {35, 35, 1},
          {36, 36, 3},
          {37, 91, 1},
          {92, 92, 4},
          {93, 122, 1},
          {123, 123, 5},
          {124, 65535, 1},
        },
        {
          {0, 33, 1},
          {35, 35, 1},
          {37, 122, -2},
          {123, 123, 6},
          {124, 65535, 1},
        },
        {
        },
        {
          {65, 90, 7},
          {95, 95, 8},
          {97, 122, 9},
          {123, 123, 10},
          {127, 255, 11},
        },
        {
          {0, 65535, 12},
        },
        {
          {0, 33, 13},
          {35, 35, 13},
          {36, 36, 14},
          {37, 91, 13},
          {92, 92, 15},
          {93, 65535, 13},
        },
        {
          {0, 35, -7},
          {37, 65535, -7},
        },
        {
          {45, 45, 16},
          {48, 57, 17},
          {65, 90, 18},
          {91, 91, 19},
          {95, 95, 20},
          {97, 122, 21},
          {127, 255, 22},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {65, 90, 23},
          {95, 95, 24},
          {97, 122, 25},
          {127, 255, 26},
        },
        {
          {45, 255, -9},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 27},
          {95, 95, 28},
          {97, 122, 29},
          {127, 255, 30},
        },
        {
          {0, 65535, 31},
        },
        {
          {62, 62, 32},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {0, 35, 33},
          {36, 36, 34},
          {37, 92, 33},
          {94, 65535, 33},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {48, 57, 35},
          {65, 90, 36},
          {95, 95, 37},
          {97, 122, 38},
          {127, 255, 39},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 57, 40},
          {65, 90, 41},
          {95, 95, 42},
          {97, 122, 43},
          {127, 255, 44},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 45},
          {95, 95, 46},
          {97, 122, 47},
          {127, 255, 48},
        },
        {
          {0, 92, 33},
          {93, 93, 49},
          {94, 65535, 33},
        },
        {
          {0, 64, 33},
          {65, 90, 50},
          {91, 92, 33},
          {93, 93, 49},
          {94, 94, 33},
          {95, 95, 51},
          {96, 96, 33},
          {97, 122, 52},
          {123, 126, 33},
          {127, 255, 53},
          {256, 65535, 33},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 57, 54},
          {65, 90, 55},
          {95, 95, 56},
          {97, 122, 57},
          {127, 255, 58},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
        },
        {
          {0, 47, 33},
          {48, 57, 59},
          {58, 64, 33},
          {65, 90, 60},
          {91, 92, 33},
          {93, 93, 61},
          {94, 94, 33},
          {95, 95, 62},
          {96, 96, 33},
          {97, 122, 63},
          {123, 126, 33},
          {127, 255, 64},
          {256, 65535, 33},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
      },
      {
        {
          {0, 35, 1},
          {36, 36, 2},
          {37, 91, 1},
          {92, 92, 3},
          {93, 122, 1},
          {123, 123, 4},
          {124, 65535, 1},
        },
        {
          {0, 35, 1},
          {37, 122, -2},
          {123, 123, 5},
          {124, 65535, 1},
        },
        {
          {65, 90, 6},
          {95, 95, 7},
          {97, 122, 8},
          {123, 123, 9},
          {127, 255, 10},
        },
        {
          {0, 65535, 11},
        },
        {
          {0, 33, 12},
          {35, 35, 12},
          {36, 36, 13},
          {37, 91, 12},
          {92, 92, 14},
          {93, 65535, 12},
        },
        {
          {0, 35, -6},
          {37, 65535, -6},
        },
        {
          {45, 45, 15},
          {48, 57, 16},
          {65, 90, 17},
          {91, 91, 18},
          {95, 95, 19},
          {97, 122, 20},
          {127, 255, 21},
        },
        {
          {45, 255, -8},
        },
        {
          {45, 255, -8},
        },
        {
          {65, 90, 22},
          {95, 95, 23},
          {97, 122, 24},
          {127, 255, 25},
        },
        {
          {45, 255, -8},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 26},
          {95, 95, 27},
          {97, 122, 28},
          {127, 255, 29},
        },
        {
          {0, 65535, 30},
        },
        {
          {62, 62, 31},
        },
        {
          {45, 255, -8},
        },
        {
          {45, 255, -8},
        },
        {
          {0, 35, 32},
          {36, 36, 33},
          {37, 92, 32},
          {94, 65535, 32},
        },
        {
          {45, 255, -8},
        },
        {
          {45, 255, -8},
        },
        {
          {45, 255, -8},
        },
        {
          {48, 57, 34},
          {65, 90, 35},
          {95, 95, 36},
          {97, 122, 37},
          {127, 255, 38},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 57, 39},
          {65, 90, 40},
          {95, 95, 41},
          {97, 122, 42},
          {127, 255, 43},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 44},
          {95, 95, 45},
          {97, 122, 46},
          {127, 255, 47},
        },
        {
          {0, 92, 32},
          {93, 93, 48},
          {94, 65535, 32},
        },
        {
          {0, 64, 32},
          {65, 90, 49},
          {91, 92, 32},
          {93, 93, 48},
          {94, 94, 32},
          {95, 95, 50},
          {96, 96, 32},
          {97, 122, 51},
          {123, 126, 32},
          {127, 255, 52},
          {256, 65535, 32},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -24},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 255, -28},
        },
        {
          {48, 57, 53},
          {65, 90, 54},
          {95, 95, 55},
          {97, 122, 56},
          {127, 255, 57},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
        },
        {
          {0, 47, 32},
          {48, 57, 58},
          {58, 64, 32},
          {65, 90, 59},
          {91, 92, 32},
          {93, 93, 60},
          {94, 94, 32},
          {95, 95, 61},
          {96, 96, 32},
          {97, 122, 62},
          {123, 126, 32},
          {127, 255, 63},
          {256, 65535, 32},
        },
        {
          {0, 65535, -51},
        },
        {
          {0, 65535, -51},
        },
        {
          {0, 65535, -51},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
          {48, 255, -46},
        },
        {
          {0, 65535, -51},
        },
        {
          {0, 65535, -51},
        },
        {
        },
        {
          {0, 65535, -51},
        },
        {
          {0, 65535, -51},
        },
        {
          {0, 65535, -51},
        },
      },
      {
        {
          {0, 35, 1},
          {36, 36, 2},
          {37, 91, 1},
          {92, 92, 3},
          {93, 95, 1},
          {96, 96, 4},
          {97, 122, 1},
          {123, 123, 5},
          {124, 65535, 1},
        },
        {
          {0, 35, 1},
          {37, 95, -2},
          {97, 122, 1},
          {123, 123, 6},
          {124, 65535, 1},
        },
        {
          {65, 90, 7},
          {95, 95, 8},
          {97, 122, 9},
          {123, 123, 10},
          {127, 255, 11},
        },
        {
          {0, 65535, 12},
        },
        {
        },
        {
          {0, 35, 13},
          {36, 36, 14},
          {37, 91, 13},
          {92, 92, 15},
          {93, 95, 13},
          {97, 65535, 13},
        },
        {
          {0, 35, 13},
          {37, 65535, -7},
        },
        {
          {45, 45, 16},
          {48, 57, 17},
          {65, 90, 18},
          {91, 91, 19},
          {95, 95, 20},
          {97, 122, 21},
          {127, 255, 22},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {65, 90, 23},
          {95, 95, 24},
          {97, 122, 25},
          {127, 255, 26},
        },
        {
          {45, 255, -9},
        },
        {
          {0, 65535, -3},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 27},
          {95, 95, 28},
          {97, 122, 29},
          {127, 255, 30},
        },
        {
          {0, 65535, 31},
        },
        {
          {62, 62, 32},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {0, 35, 33},
          {36, 36, 34},
          {37, 92, 33},
          {94, 65535, 33},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {45, 255, -9},
        },
        {
          {48, 57, 35},
          {65, 90, 36},
          {95, 95, 37},
          {97, 122, 38},
          {127, 255, 39},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 57, 40},
          {65, 90, 41},
          {95, 95, 42},
          {97, 122, 43},
          {127, 255, 44},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {0, 65535, -3},
        },
        {
          {65, 90, 45},
          {95, 95, 46},
          {97, 122, 47},
          {127, 255, 48},
        },
        {
          {0, 92, 33},
          {93, 93, 49},
          {94, 65535, 33},
        },
        {
          {0, 64, 33},
          {65, 90, 50},
          {91, 92, 33},
          {93, 93, 49},
          {94, 94, 33},
          {95, 95, 51},
          {96, 96, 33},
          {97, 122, 52},
          {123, 126, 33},
          {127, 255, 53},
          {256, 65535, 33},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -25},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 255, -29},
        },
        {
          {48, 57, 54},
          {65, 90, 55},
          {95, 95, 56},
          {97, 122, 57},
          {127, 255, 58},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
        },
        {
          {0, 47, 33},
          {48, 57, 59},
          {58, 64, 33},
          {65, 90, 60},
          {91, 92, 33},
          {93, 93, 61},
          {94, 94, 33},
          {95, 95, 62},
          {96, 96, 33},
          {97, 122, 63},
          {123, 126, 33},
          {127, 255, 64},
          {256, 65535, 33},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {48, 255, -47},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
        {
          {0, 65535, -52},
        },
      },
    };
    */

    private static int[][] accept; /* = {
      {
  -1, 2, -1, -1, 2, 1, -1, 2, 0, -1, -1, 2, -1, -1, 2, 1, -1, 2, 

      },
      {
  6, 111, 111, 111, 111, 73, 115, -1, 98, 82, 74, -1, 87, 88, 79, 85, 97, 86, 96, 81, 108, 108, 94, 93, 65, 78, 66, 99, 80, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 91, 92, 76, 110, 117, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 89, 75, 90, 77, 110, 111, 67, -1, 112, 112, 109, 109, 109, 109, 50, 69, 52, -1, 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 47, 83, 45, 84, 46, 59, 107, 49, -1, -1, 48, 107, -1, -1, -1, 95, 56, 63, 60, 58, 64, 57, 3, 110, 110, 110, 110, 15, 110, 110, 110, 110, 15, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 19, 110, 19, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 4, 110, 4, 110, 110, 110, 110, 110, 70, 70, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 51, 53, 68, 62, 112, 109, 109, 109, 109, 109, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 112, 112, -1, -1, 107, 108, 108, 108, -1, 54, 61, 55, 71, 71, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 14, 14, 110, 110, 110, 110, 110, 110, 110, 110, 33, 33, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 28, 28, 110, 110, 72, 72, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 107, -1, 113, 112, 44, 44, 44, 44, 110, 110, 110, 110, 21, 21, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 40, 40, 9, 9, 110, 110, 110, 110, 110, 110, 110, 110, 27, 27, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 35, 35, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 43, 43, 110, 110, -1, -1, -1, -1, -1, 100, -1, -1, -1, -1, -1, -1, -1, 44, 44, 44, 44, 44, 34, 34, 24, 24, 110, 110, 31, 31, 110, 110, 110, 110, 110, 110, -1, -1, -1, -1, 10, 110, 110, 110, 110, 8, 8, 110, 110, 110, 110, 110, 110, 43, 43, 110, 110, 110, 110, 110, 110, 110, 110, 42, 42, 110, 110, 110, 110, 110, 110, 110, 110, 17, 17, -1, -1, 105, -1, -1, -1, -1, -1, -1, 101, -1, -1, 110, 110, 110, 110, 110, 110, 110, 110, -1, 5, 5, 16, 16, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 29, 29, 110, 110, 110, 110, 26, 26, 30, 30, 20, 20, -1, 103, -1, -1, -1, -1, -1, -1, 106, 110, 110, 110, 110, 41, 41, 22, 22, 110, 110, 110, 110, 110, 110, 32, 32, 12, 12, 110, 110, 38, 38, 36, 36, -1, -1, -1, 104, -1, 102, 110, 110, 11, 11, 110, 110, 110, 110, 18, 18, 25, 25, 110, 110, 25, 25, 110, 110, 23, 23, 110, 110, 110, 110, 13, 13, 110, 110, 110, 110, 110, 110, 110, 110, 39, 39, 37, 37, 

      },
      {
  132, 126, 116, 127, -1, 127, -1, 122, 122, 122, -1, 122, 126, 126, -1, -1, -1, 122, 122, -1, 122, 122, 122, 119, 119, 119, 119, 119, 119, 119, 119, 126, -1, -1, -1, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 125, 125, 125, 125, 124, -1, -1, -1, -1, 125, 125, 125, 125, 125, -1, -1, 123, -1, -1, -1, 

      },
      {
  135, 128, 129, -1, 129, -1, 122, 122, 122, -1, 122, 128, 128, -1, -1, -1, 122, 122, -1, 122, 122, 122, 120, 120, 120, 120, 120, 120, 120, 120, 128, -1, -1, -1, 120, 120, 120, 120, 120, 120, 120, 120, 120, 120, 125, 125, 125, 125, 124, -1, -1, -1, -1, 125, 125, 125, 125, 125, -1, -1, 123, -1, -1, -1, 

      },
      {
  136, 130, 131, -1, 118, 131, -1, 122, 122, 122, -1, 122, 130, 130, -1, -1, -1, 122, 122, -1, 122, 122, 122, 121, 121, 121, 121, 121, 121, 121, 121, 130, -1, -1, -1, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 125, 125, 125, 125, 124, -1, -1, -1, -1, 125, 125, 125, 125, 125, -1, -1, 123, -1, -1, -1, 

      },
    };
    */

    static
    {
        try
        {
            BufferedReader r = new BufferedReader (new InputStreamReader (
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = Integer.parseInt(r.readLine());
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = Integer.parseInt(r.readLine());
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = Integer.parseInt(r.readLine());
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = Integer.parseInt(r.readLine());
                        }
                    }
                }
            }

            // read accept
            length = Integer.parseInt(r.readLine());
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = Integer.parseInt(r.readLine());
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = Integer.parseInt(r.readLine());
                }
            }

            r.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }

    public static class State
    {
        public final static State HTML = new State(0);
        public final static State CODE = new State(1);
        public final static State STRING = new State(2);
        public final static State HEREDOC = new State(3);
        public final static State BACKTICK = new State(4);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
